import { SET_CUSTOMERS, SET_LOADING_CUSTOMERS, SET_SHOW_CUSTOMER_FORM } from '@/constants/mutationTypes'
import { INIT_CUSTOMERS, SHOW_CUSTOMER_FORM, HIDE_CUSTOMER_FORM, SUBMIT_CUSTOMER } from '@/constants/actionTypes'

const initialState = {
    customers: [],
    loadingCustomers: false,
    showingCustomerForm: false
}

const state = {
    customers: initialState.customers,
    loadingCustomers: !initialState.loadingCustomers,
    showingCustomerForm: initialState.showingCustomerForm
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    customers(state) {
        return state.customers
    },
    /**
     * 
     * @param {*} state 
     */
    loadingCustomers(state) {
        return state.loadingCustomers
    },
    /**
     * 
     * @param {*} state 
     */
    showingCustomerForm(state) {
        return state.showingCustomerForm
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_CUSTOMERS] (state, payload) {
        state.customers = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_CUSTOMERS] (state, payload) {
        state.loadingCustomers = !!payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_SHOW_CUSTOMER_FORM] (state, payload) {
        state.showingCustomerForm = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_CUSTOMERS] ({ commit }, payload) {
        commit(SET_CUSTOMERS, payload)
        commit(SET_LOADING_CUSTOMERS)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [SHOW_CUSTOMER_FORM] ({ commit }) {
        commit(SET_SHOW_CUSTOMER_FORM, true)
    },
    /**
     * 
     * @param {*} param0 
     */
    [HIDE_CUSTOMER_FORM] ({ commit }) {
        commit(SET_SHOW_CUSTOMER_FORM, false)
    },
    /**
     * 
     * @param {*} param0 
     */
    [SUBMIT_CUSTOMER] ({ commit }) {
        console.log('submit')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}